#include "Eigen/Dense"
#include <iostream>
#include <cassert>

template<typename T, int M, int N>
void NormalEquation(const Eigen::Matrix<T,M,N> &A, Eigen::Matrix<T,N,1> &p, const Eigen::Matrix<T,M,1> &y) { 
  p=(A.transpose()*A).llt().solve(A.transpose()*y);
}

int main(int argc, char* argv[]) {
  assert(argc==3); auto m=std::stoi(argv[1]), n=std::stoi(argv[2]);
  using T=double;
  using MT=Eigen::Matrix<T,Eigen::Dynamic,Eigen::Dynamic>;
  using VT=Eigen::Matrix<T,Eigen::Dynamic,1>;
  MT A=MT::Random(m,n); VT p(n), y=VT::Random(m);
  NormalEquation(A,p,y);
  std::cout << "p=" << p.transpose()<< std::endl;
  std::cout << "||A*p-y||=" << (A*p-y).squaredNorm() << std::endl;
  std::cout << "||A^T*A*p-A^T*y||=" << (A.transpose()*A*p-A.transpose()*y).norm() << std::endl;
  return 0;
}
